<?php
/*
Plugin Name: WP Upload Manager (de)
Plugin URI: http://www.bueltge.de/wp-upload-manager-de-plugin/92/
Description: WP File Upload Manager. Zugang &uuml;ber: <a href="admin.php?page=wp-upload-manager_de.php">Verwalten -> Uploads</a> <a href="http://www.bueltge.de">(de: bueltge.de)</a>
Author: Au Yong Tien Chee (de:bueltge.de)
Version: 1.1 de
Author URI: http://auyongtc.theuseless.com
*/

function uploadManagerPage() 
{
	$selectFilesMenu = '';
	$uploadpath = get_settings('fileupload_realpath');
	$uploadurl = get_settings('fileupload_url');
	
	if (isset($_POST["btnSubmit2"])) {
		if ($_POST["btnSubmit2"] == "Ja") {
			$fullfilename = $uploadpath . "/" . basename($_POST["file"]);
			$updatedMessage .= uploadManagerDeleteFile($fullfilename);
		}
	}
	
	if (isset($_POST["btnSubmit"])) {
		if ($_POST["mnuFiles"] == "") {
			$updatedMessage = "<strong>FEHLER:</strong> Unvollst&auml;ndige Daten! Bitte nochmal versuchen.";
		} else {
			$selectedfile = $_POST["mnuFiles"];
			$updatedMessage = uploadManagerQueryFileReference($selectedfile);
		}
	}
	
/*	$dirls = explode("\n", `ls $uploadpath/*.*`); funktioniert nicht im safe mode [Error: shell_exec()], Zeile 34-41 fuer safe mode von Igor - http://www.ikrout.com */
	$dir_files = opendir($uploadpath);
		$v=0;
		while ($fil = readdir ($dir_files)) :
			if ($fil != "." && $fil != "..") {
				$dirls[$v] = $fil;
				$v++;
			}
		endwhile;
	closedir($dir_files);
	for ($i = 0; $i < (count($dirls)); $i++) {
		$file = basename($dirls[$i]);
		$selectFilesMenu .= "<option value='$uploadurl/$file'>$file</option>\n";
	}
	
	include_once(ABSPATH . "wp-content/wp-upload-manager/admin.tpl.php");
}

function uploadManagerQueryFileReference($file) {
	global $wpdb;
	$siteurl = get_settings('siteurl');
	$message = "";
	
	if ($posts = $wpdb->get_results("SELECT ID, post_title FROM wp_posts WHERE post_excerpt LIKE '%$file%' 
		OR post_content LIKE '%$file%' ORDER BY ID ASC")) {
		$message = "Diese Datei ($file) wird im(n) folgenden Beitrag(&auml;gen) benutzt: <br /><ul>\n";
		foreach ($posts as $post) {
			$message .= "<li>" . $post->post_title . " ( <a href='$siteurl" . "/wp-admin/post.php?action=edit&post=$post->ID' target='_blank'>&Auml;ndern</a> )</li><br />\n";
		}
		$message .= "</ul>\n";
	} else $message = "Diese Datei ($file) wird in keinem Beitrag genutzt.<br /><br />\n";
	return $message;
}

function uploadManagerDeleteFile($file)
{
	if (unlink($file)) return "Datei erfolgreich gel&ouml;scht";
	else return "Fehler mit gel&ouml;schter Datei!";
}

function uploadManagerAdminJavascript() 
{
	echo "<script type='text/javascript'>\n";
	echo "function showPreview() {\n";
    echo "  var selectedfile = document.frmDelFiles.mnuFiles.options[document.frmDelFiles.mnuFiles.selectedIndex].value\n";
	echo "  if (selectedfile.match(/\.(gif|jpg|png)$/)) {\n";
	echo "	  if (!document.images) return\n";
    echo "	  document.images.preview.src = selectedfile\n";
    echo "  } else document.images.preview.src = '';\n";
    echo "}\n";
    echo "</script>";
}
	
function displayUploadManagerAdminPage() 
{
	add_management_page("WP-Upload Manager (de)", "Uploads", 6, __FILE__, 'uploadManagerPage');
}

add_action('admin_head', 'uploadManagerAdminJavascript');
add_action('admin_menu', 'displayUploadManagerAdminPage');
?>